<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         mod_site.php
Description:  Functions for the site area (page building)

*/

    include "mod_config.php";
    include "class_theme.php";

    // functions
    
    // Fille the main page with replaces
    function build_page($themeId, $pageId, $withNavigation = true, $withBackLink = true, $naviLevelOverride = "")
    {
        global $SHOP_MAIN_SITE;
        global $THEME_FOLDER;
        
        global $THMREP_FILE_NAVIGATION;
        global $THMREP_FILE_FOOTER;
        global $THMREP_BODY_BACKLINK;

        $thmTheme = new cTheme;
        $thmTheme->SetFolder(retrieve_absolute_path($THEME_FOLDER));

        // Check, if page has a specific theme file...
//        $themeFile = $thmTheme->GetCompleteFolder() . $thmTheme->GetMainFile();
        $themeFile = $thmTheme->GetMainFile();
//        $contPage = file_get_contents($thmTheme->GetCompleteFolder() . $thmTheme->GetMainFile());
        $contPage = file_get_contents($themeFile);

        // 1. Include footer into page, cause a navigation might be in there...
        $contFooter = get_shop_footer();
        if ($contFooter == "")  // Not cutomized?
//        $contPage = file_get_contents($thmTheme->GetCompleteFolder() . $thmTheme->GetMainFile());
            $contFooter = file_get_contents($thmTheme->GetFooterFile());
        $contPage = str_replace($THMREP_FILE_FOOTER, $contFooter, $contPage);

        // 2. Include navigation into page
        $showLevels = $naviLevelOverride;
        $navLevels = get_navigation_levels($themeId);
        $navEntries = get_navigation_entries($themeId, $showLevels);
        $contNavigation = "";
        for ($i = 0; $i < count($navLevels); $i ++)
        {
            $contNavigation = "";
            if ($withNavigation == false)
            {
                $contPage = str_replace(sprintf($THMREP_FILE_NAVIGATION, $i), $contNavigation, $contPage);
            }
            else
            {
                if ($navEntries[$i] == "")  // Is this navigation level is not wanted for this page?
                    $contPage = str_replace(sprintf($THMREP_FILE_NAVIGATION, $i), $contNavigation, $contPage);
                else  // It is wanted for this page...
                    $contPage = str_replace(sprintf($THMREP_FILE_NAVIGATION, $i), build_navigation($i, $navLevels[$i], $navEntries[$i]), $contPage);
            }
        }

        // 3. Do the head parameter replacements
        $contPage = fill_head_parameters($contPage);
        
        // 4. Backlink
        if ($withBackLink == true)
            $contBackLink = $SHOP_MAIN_SITE;
        else
            $contBackLink = "";
        $contPage = str_replace($THMREP_BODY_BACKLINK, $contBackLink, $contPage);

        // 5. Some additional stuff
        $contAuthor = "";
        $contModified = date("Y-m-d H:i:s");
        $contPage = fill_site_parameters($contPage, $contAuthor, $contModified);
        
        return $contPage;
    }

    // Retrieve array of navigation levels
    function get_navigation_levels($themeId)
    {
        global $THEME_FOLDER;
        global $THMREP_FILE_SPLIT;

        $thmTheme = new cTheme;
        $thmTheme->SetFolder(retrieve_absolute_path($THEME_FOLDER));
        $thmTheme->LoadThemeFromId($themeId);

//        $contNav = file_get_contents($thmTheme->GetCompleteFolder() . $thmTheme->GetNavigationFile());
        $contNav = file_get_contents($thmTheme->GetNavigationFile());

        $navLevels = explode($THMREP_FILE_SPLIT, $contNav);
        
        return $navLevels;
    }
    
    // Retrieve array of navigation entries
    function get_navigation_entries($themeId, $showLevels)
    {
        global $THEME_FOLDER;
        global $THMREP_FILE_SPLIT;

        $thmTheme = new cTheme;
        $thmTheme->SetFolder(retrieve_absolute_path($THEME_FOLDER));
        $thmTheme->LoadThemeFromId($themeId);

//        $contNavEntry = file_get_contents($thmTheme->GetCompleteFolder() . $thmTheme->GetNavigationEntryFile());
        $contNavEntry = file_get_contents($thmTheme->GetNavigationEntryFile());

        $navEntries = explode($THMREP_FILE_SPLIT, $contNavEntry);
        if ($showLevels != "") // Not all levels?
        {
            $levels = explode(';', $showLevels);
            for ($i = 0; $i < count ($navEntries); $i ++)
            {
                if (in_array($i, $levels) == false)
                    $navEntries[$i] = "";  // Not found, empty it
            }
        }

        return $navEntries;
    }
    
    // Build the navigation replacement by level, navigation and entry container
    function build_navigation($navLevel, $navContainer, $navEntryContainer)
    {
        global $THMREP_BODY_NAVIGATION_LINK;
        global $THMREP_BODY_NAVIGATION_TEXT;
        global $THMREP_FILE_NAVIGATION_ENTRY;

        $contOutput = "";
        $contTempEntry = "";
        if ($navLevel == 0)  // Shop has just one level, until yet :)
        {
            $naviLinks = get_shop_navigationlinks();
            $naviTitles = get_shop_navigationtitles();
            for ($i = 0; $i < count($naviLinks); $i ++)
            {
                $contTempEntry = $navEntryContainer;
                $contTempEntry = str_replace($THMREP_BODY_NAVIGATION_LINK , $naviLinks[$i], $contTempEntry);
                $contTempEntry = str_replace($THMREP_BODY_NAVIGATION_TEXT , $naviTitles[$i], $contTempEntry);
                $contOutput = $contOutput . $contTempEntry;
            }
        }
        return str_replace(sprintf($THMREP_FILE_NAVIGATION_ENTRY, $navLevel), $contOutput, $navContainer);
    }
    
    // Insert site counter
    function build_site_counter()
    {
       global $SHOP_SHOWCOUNTER;
       global $SHOP_COUNT;
       global $SHOP_COUNT_LOG;
       global $SHOP_COUNT_IPADDR;
       global $ADMIN_LOG_ARCHIVE;
       global $MAX_LOG_SIZE;

	   $count = new class_counter;
       $count->set_files($SHOP_COUNT, $SHOP_COUNT_LOG, $SHOP_COUNT_IPADDR, $ADMIN_LOG_ARCHIVE);
	   $count->set_max_logsize($MAX_LOG_SIZE);
	   $count->increase("A new visitor");
	   if ($SHOP_SHOWCOUNTER == "1")
           return '<br><br><p align="center"><b> - ' . $count->current_count_m . ' - </b></p>';

       return "";
    }
    
    // Build the sites content
    function build_site_content($contentPosition, $mainContent, $additionalContent)
    {
        global $ALIGN_TOP;
        global $ALIGN_BOTTOM;
        global $ALIGN_LEFT;
        global $ALIGN_RIGHT;
        
        $sContent = "";
        if ($contentPosition == $ALIGN_TOP || $contentPosition == "")
            $sContent = $mainContent . $additionalContent;
        else if ($contentPosition == $ALIGN_BOTTOM)
            $sContent = $additionalContent . $mainContent;
        else if ($contentPosition == $ALIGN_LEFT)
        {
            $sContent .= echo_sr('<table class="contmain_tbl" border="0">');
            $sContent .= echo_sr('  <tr class="contmain_tbl_tbltr">');
            $sContent .= echo_sr('    <td class="contmain_tbl_tbltdleft">');
            $sContent .= echo_sr($mainContent);
            $sContent .= echo_sr('    </td>');
            $sContent .= echo_sr('    <td class="contmain_tbl_tbltdright">');
            $sContent .= echo_sr($additionalContent);
            $sContent .= echo_sr('    </td>');
            $sContent .= echo_sr('  </tr>');
            $sContent .= echo_sr('</table>');
        }
        else if ($contentPosition == $ALIGN_RIGHT)
        {
            $sContent .= echo_sr('<table class="contmain_tbl" border="0">');
            $sContent .= echo_sr('  <tr class="contmain_tbl_tbltr">');
            $sContent .= echo_sr('    <td class="contmain_tbl_tbltdleft">');
            $sContent .= echo_sr($additionalContent);
            $sContent .= echo_sr('    </td>');
            $sContent .= echo_sr('    <td class="contmain_tbl_tbltdright">');
            $sContent .= echo_sr($mainContent);
            $sContent .= echo_sr('    </td>');
            $sContent .= echo_sr('  </tr>');
            $sContent .= echo_sr('</table>');
        }

        return $sContent;
    }

    function fill_head_parameters($content)
    {
        global $SHOP_METADESCRIPTION;
        global $SHOP_METATAGS;
        global $SHOP_METAREVISIT;
        global $SHOP_CHARSET_FORMAT;
        global $THMREP_HEAD_DESCRIPTION;
        global $THMREP_HEAD_TAGS;
        global $THMREP_HEAD_REVISIT;
        global $THMREP_HEAD_CHARSET;

        $content = str_replace($THMREP_HEAD_DESCRIPTION, $SHOP_METADESCRIPTION, $content);
        $content = str_replace($THMREP_HEAD_TAGS, $SHOP_METATAGS, $content);
        $content = str_replace($THMREP_HEAD_REVISIT, $SHOP_METAREVISIT, $content);
        $content = str_replace($THMREP_HEAD_CHARSET, $SHOP_CHARSET_FORMAT, $content);

        return $content;
    }
    
    function fill_site_parameters($content, $author, $modified)
    {
        global $SHOP_TITLE;
        global $THMREP_SITE_TITLE;
        global $THMREP_SITE_DATE;
        global $THMREP_SITE_TIME;
        global $THMREP_SITE_YEAR;
        global $THMREP_SITE_AUTHOR;
        global $THMREP_SITE_MODIFIED;

        $content = str_replace($THMREP_SITE_TITLE, $SHOP_TITLE, $content);
        $content = str_replace($THMREP_SITE_DATE, date("Y-m-d"), $content);
        $content = str_replace($THMREP_SITE_TIME, date("H:i:s"), $content);
        $content = str_replace($THMREP_SITE_YEAR, date("Y"), $content);
        $content = str_replace($THMREP_SITE_AUTHOR, $author, $content);
        $content = str_replace($THMREP_SITE_MODIFIED, $modified, $content);

        return $content;
    }
    
    function fill_titles($content, $siteTitle, $pageTitle)
    {
        global $THMREP_HEAD_TITLE;
        global $THMREP_BODY_TITLE;
        
        $content = str_replace($THMREP_HEAD_TITLE, $siteTitle, $content);
        $content = str_replace($THMREP_BODY_TITLE, $pageTitle, $content);

        return $content;
    }
    
    function fill_content($content, $pageContent, $pageAddContent = "", $pageAddContent2 = "")
    {
        global $THMREP_BODY_CONTENT;
        global $THMREP_BODY_ADDCONTENT;
        global $THMREP_BODY_ADDCONTENT2;

        $content = str_replace($THMREP_BODY_CONTENT, $pageContent, $content);
        $content = str_replace($THMREP_BODY_ADDCONTENT, $pageAddContent, $content);
        $content = str_replace($THMREP_BODY_ADDCONTENT2, $pageAddContent2, $content);

        return $content;
    }
    
    function fill_emptyvars($content)
    {
        // Replace all $$THM_...$$ that might no be used!!
        global $THMREP_VAR_PATTERN;
        $content = preg_replace($THMREP_VAR_PATTERN, "", $content);
        return $content;
    }

    function retrieve_absolute_path($fileName)
    {
        if (substr($fileName, 0, 3) == "../")
            return substr($fileName, 3);
        return $fileName;
    }

    // Build error message
    function build_error_message($msgString, $pageContent)
    {
        global $ERROR_IMAGE;

        $sError = "";
        $sError = $sError . echo_sr('<table class="error_tbl">');
        $sError = $sError . echo_sr('<tr>');
        $sError = $sError . echo_sr('  <td><img src="' . $ERROR_IMAGE . '" alt=""></td>');
        $sError = $sError . echo_sr('  <td><b>' . $msgString . '</b><br></td>');
        $sError = $sError . ('</tr></table>');

        return inject_into_body($sError, $pageContent);
    }
    
    // Inject something into body content
    function inject_into_body($injectCode, $pageContent, $bAtBeginning = true)
    {
        global $LINE_FEED;
        if ($bAtBeginning == true)
            return str_replace("<body>", "<body>" . $LINE_FEED . $injectCode, $pageContent);

        return str_replace("</body>", $injectCode . $LINE_FEED . "</body>", $pageContent);
    }

    // Inject something into head content
    function inject_into_head($injectCode, $pageContent, $bAtBeginning = true)
    {
        global $LINE_FEED;
        if ($bAtBeginning == true)
            return str_replace("<head>", "<head>" . $LINE_FEED . $injectCode, $pageContent);

        return str_replace("</head>", $injectCode . $LINE_FEED . "</head>", $pageContent);
    }

?>