<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         shop_article_order.php
Description:  Shop ordering page

*/
    include "../modules/mod_config.php";
    include "../modules/mod_shop.php";

    // Check for maintenance mode...
    if ($SHOP_MAINTENANCE_MODE == true)
    {
        include $ADMIN_MAINTENANCE_SITE;
        return;
    }

    // Check for login...
    $checkLogin = check_login();
    if ($checkLogin == false && $FORCE_CUSTOMER_LOGIN == true)
    {
        header ("location: " . $SHOP_LOGIN_SITE);
        return;
    }
    if ($checkLogin == false && $FORCE_CUSTOMER_REGISTRATION == true)
    {
        header ("location: " . $SHOP_REGISTER_BACKTOORDER_SITE);
        return;
    }


    include "../modules/class_article.php";
    include "../modules/class_basket.php";
    include "../modules/class_user.php";
    include "../modules/class_userlist.php";
    include "../modules/class_order.php";
    include "../modules/class_translation.php";
    include "../modules/class_textfile.php";

    // Session starts first :-)
    $basket = new cBasket;
    $basket->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
    $basket->InitSession();
    $basket->LoadFromSession();
    $basketCount = 0;
    $basketValue = 0;

    $cFile = new cTextFile;

    $errorMessage = "";
    $art = new cArticle;
    $art->SetFolder($ARTICLE_FOLDER);
    $art->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);

    // Cancel order
    if (isset($_POST['ord_Cancel']) == true)
    {
        header("location: " . $SHOP_MAIN_SITE);
        return;
    }

    // Change order
    if (isset($_POST['ord_Change']) == true)
    {
        header("location: " . $SHOP_BASKET_SITE);
        return;
    }

    // Finish the order
    if (isset($_POST['ord_FinishOrder']) == true && $basket->IsEmpty() == false)
    {
        $b_ErrorOccured = false;
        if (!ereg("^.+@.+\\..+$", $_POST['usr_email']))
        {
            $errorMessage = $cTrans->GetTranslation('shop_order_erroremail') . '!';
            $b_ErrorOccured = true;
        }
        else if (isset($_POST['ord_accept']) == false || $_POST['ord_accept'] != "1")
        {
            $errorMessage = $cTrans->GetTranslation('shop_order_erroreaccept') . '!';
            $b_ErrorOccured = true;
        }
        else if ($checkLogin == false && (isset($_POST['ord_checksum']) == false || isset($_POST['ord_checksum_org']) == false ||
                 ($_POST['ord_checksum'] != $_POST['ord_checksum_org'])))
        {
            $errorMessage = $cTrans->GetTranslation('shop_order_errorechecksum') . '!';
            $b_ErrorOccured = true;
        }
        else
        {
            $missingElement = "";
            if ($_POST['usr_firstname'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_order_firstname');
            if ($_POST['usr_lastname'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_order_lastname');
            if ($_POST['usr_street'] == "")
                $missingElement = $missingElement . '<br> -> ' . $cTrans->GetTranslation('shop_order_street');
            if ($_POST['usr_streetno'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_order_streetno');
            if ($_POST['usr_city'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_order_city');
            if ($_POST['usr_zipcode'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_order_zipcode');
            if ($_POST['usr_land'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_order_land');
            if ($_POST['usr_phoneno'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_order_phoneno');
            if ($_POST['usr_email'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_order_email');

            if ($missingElement != "")
            {
                $errorMessage = $cTrans->GetTranslation('shop_order_erroraddress') . ': ' . $missingElement;
                $b_ErrorOccured = true;
            }
            else // Do the order
            {
                $ordOrder = new cOrder;
                $ordOrder->CreateOrder();
                $ordOrder->SetFolder($ORDER_FOLDER);
                $ordOrder->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
                $ordOrder->m_ordBasket = $basket;
                $ordOrder->SetShippingType($_POST['ord_shiptype']);
                $ordOrder->SetShippingCost($_POST['ord_shipcost']);
                $ordOrder->SetFirstName($_POST['usr_firstname']);
                $ordOrder->SetLastName($_POST['usr_lastname']);
                $ordOrder->SetStreet($_POST['usr_street']);
                $ordOrder->SetStreetNo($_POST['usr_streetno']);
                $ordOrder->SetCity($_POST['usr_city']);
                $ordOrder->SetZipCode($_POST['usr_zipcode']);
                $ordOrder->SetLand($_POST['usr_land']);
                $ordOrder->SetTelephoneNo($_POST['usr_phoneno']);
                $ordOrder->SetEmail($_POST['usr_email']);
                if ($ordOrder->SaveOrder() == false) // Order failed
                {
                    // Display order failed
                    $contPage = build_page($SHOP_THEME, false, true, true, "");
                    $titleArray = get_shop_navigationtitles();
                    $contPage = fill_titles($contPage, $SHOP_TITLE, $titleArray[2]);
                    $contPage = build_error_message($cTrans->GetTranslation('shop_order_errororder'));

                    // Main content
                    $contMain = build_shop_login();
                    $contMain .= $cFile->LoadFromFile($ORDERTITLE_CONFIG_FILE);
                    $contMain .= echo_sr ('<br><table class="con_tbl" id="orderfailed_con_tbl"><tr><td>');
                    $contMain .= echo_sr ($cTrans->GetTranslation('shop_order_errororder'));
                    $contMain .= echo_sr ('</td></tr></table>');
                    $contMain .= build_shop_bottom_links("ord_Cancel", $cTrans->GetTranslation('shop_order_backtoshop'));

                    // Put content together
                    $contContent = build_site_content($ALIGN_TOP, $contMain, "");
                    $contPage = fill_content($contPage, $contContent, "", "");
                    $contPage = fill_emptyvars($contPage);

                    echo_r($contPage);

                    // Send email to admin?
                    if ($ADMIN_MAILON_ORDERFAILED == true)
                        send_mail($ADMIN_EMAIL, $SHOP_TITLE . ': ' . $cTrans->GetTranslation('shop_link_order'), $cTrans->GetTranslation('shop_order_errororder') . ', Id: ' . $ordOrder->GetId(), $SHOP_TITLE . '<' . $SHOP_ORDEREMAIL . '>');
                    return;
                }
                else  // Order succeeded
                {
                    // Send a email to the webshop owner
                    $aTranslations = array();
                    $aTranslations['title'] = $cTrans->GetTranslation('shop_order_mailtitle');
                    $aTranslations['address'] = $cTrans->GetTranslation('shop_order_mailaddress');
                    $aTranslations['email'] = $cTrans->GetTranslation('shop_order_mailemail');
                    $aTranslations['phoneno'] = $cTrans->GetTranslation('shop_order_mailphoneno');
                    $aTranslations['shiptype'] = $cTrans->GetTranslation('shop_order_mailshiptype');
                    $aTranslations['articles'] = $cTrans->GetTranslation('shop_order_mailarticle');
                    $aTranslations['id'] = $cTrans->GetTranslation('shop_order_mailid');
                    $aTranslations['name'] = $cTrans->GetTranslation('shop_order_mailname');
                    $aTranslations['count'] = $cTrans->GetTranslation('shop_order_mailcount');
                    $aTranslations['userdef'] = $cTrans->GetTranslation('shop_order_mailuserdef');
                    $aTranslations['hint'] = $cTrans->GetTranslation('shop_order_mailhint') . ': ' . get_admin_link();
                    $destEmail = $SHOP_ORDEREMAIL;
                    // Include admin to order mail?
                    if ($ADMIN_MAILON_ORDERDONE == true)
                        $destEmail = $destEmail . ', ' . $ADMIN_EMAIL;
                    // Send order mail to shop owner/admin
                    $ordOrder->SendOrder($destEmail, $SHOP_TITLE . '<' . $SHOP_ORDEREMAIL . '>', $aTranslations, $ARTICLE_FOLDER, $MAIL_FOLDER);
                    // Send an email to the customer?
                    if ($SHOP_CUSTOMEREMAIL == true)
                    {
                        unset($aTranslations);
                        $aTranslations = array();
                        $aTranslations['title'] = $SHOP_TITLE . ' - ' . $cTrans->GetTranslation('shop_order_custmailtitle');
                        $aTranslations['articles'] = $cTrans->GetTranslation('shop_order_custmailarticle');
                        $aTranslations['name'] = $cTrans->GetTranslation('shop_order_custmailname');
                        $aTranslations['count'] = $cTrans->GetTranslation('shop_order_custmailcount');
                        $aTranslations['price'] = $cTrans->GetTranslation('shop_order_custmailprice');
                        $aTranslations['userdef'] = $cTrans->GetTranslation('shop_order_custmailuserdef');
                        $aTranslations['shiptype'] = $cTrans->GetTranslation('shop_order_custmailshiptype');
                        $aTranslations['totalprice'] = $cTrans->GetTranslation('shop_order_custmailtotalprice');

                        $ordOrder->SendCustomerOrder($ordOrder->GetEmail(), $SHOP_TITLE . '<' . $SHOP_ORDEREMAIL . '>', $aTranslations, $ARTICLE_FOLDER, $cFile->LoadFromFile($CUSTMAIL_CONFIG_FILE), $SHOP_CURRENCY, $MAIL_FOLDER);
                        // Send a copy to admin, too?
                        if ($ADMIN_MAILON_AUTOCUSTEMAIL == true)
                            $ordOrder->SendCustomerOrder($ADMIN_EMAIL, $SHOP_TITLE . '<' . $SHOP_ORDEREMAIL . '>', $aTranslations, $ARTICLE_FOLDER, $cFile->LoadFromFile($CUSTMAIL_CONFIG_FILE), $SHOP_CURRENCY, $MAIL_FOLDER);
                    }
                    // Check if customer does already exist
                    if ($checkLogin == false)  // Do not update logged in customers!
                    {
                        $cusCustomer = new cUser();
                        $customerList = new cUserList;
                        $customerList->SetFolder($CUSTOMER_FOLDER);
                        $customerId = $customerList->GetUserIdByEmail($_POST['usr_email']);
                        if ($customerId == false)
                        {
                            // Create a new customer
                            $cusCustomer->CreateUserFromOrder($ordOrder);
                        }
                        else
                        {
                            // Update existing cutsomer
                            $cusCustomer->UpdateUserFromOrder($ordOrder, $customerId);
                        }
                        $cusCustomer->SetFolder($CUSTOMER_FOLDER);
                        // Newsletter?
                        if (isset($_POST['ord_newsletter']) && $_POST['ord_newsletter'] == 1)
                            $cusCustomer->SetWantsNewsletter(true);
                        $cusCustomer->SaveUser();
                    }
                    // Do statistic, clear basket afterwards
                    $artIds = $basket->GetArticleIds();
                    $artCounts = $basket->GetCounts();
                    for ($i = 0; $i < count($artIds); $i ++)
                    {
                         $art->LoadArticleFromId($artIds[$i]);
                         // Update article amounts as well...
                         if ($USE_ARTICLE_AMOUNTS == true && $art->IsArticleAmountUnlimited() == false)
                             $art->SetArticleAmount($art->GetArticleAmount() - $artCounts[$i]);
                         $art->IncreaseOrderCount($artCounts[$i]);
                    }
                    $basket->ClearBasket();
                    $basket->SaveToSession();
                    // Display order finished
                    $contPage = build_page($SHOP_THEME, false, true, true, "");
                    $titleArray = get_shop_navigationtitles();
                    $contPage = fill_titles($contPage, $SHOP_TITLE, $titleArray[2]);

                    // Main content
                    $contMain = build_shop_login();
                    $contMain .= $cFile->LoadFromFile($ORDERTITLE_CONFIG_FILE);
                    $contMain .= echo_sr ('<br><br>' . $cTrans->GetTranslation('shop_order_finished') . '! (Id = ' . $ordOrder->GetId() . ')<br><br>');
                    $contMain .= build_shop_bottom_links("ord_Cancel", $cTrans->GetTranslation('shop_order_backtoshop'));

                    // Put content together
                    $contContent = build_site_content($ALIGN_TOP, $contMain, "");
                    $contPage = fill_content($contPage, $contContent, "", "");
                    $contPage = fill_emptyvars($contPage);

                    echo_r($contPage);
                    return;
                }
            }
        }
    }

    // Display order content
    $contPage = build_page($SHOP_THEME, false, true, true, "");
    $titleArray = get_shop_navigationtitles();
    $contPage = fill_titles($contPage, $SHOP_TITLE, $titleArray[2]);

    // Error occured?
    if ($errorMessage != "")
        $contPage = build_error_message($errorMessage, $contPage);

    // Display main order content
    $contMain = build_shop_login();
    $contMain .= $cFile->LoadFromFile($ORDERTITLE_CONFIG_FILE);
    if ($basket->IsEmpty() == true)
    {
        $contMain .= echo_sr ('<br><p><b>' . $cTrans->GetTranslation('shop_order_empty') . '!</b></p><br>');
        $contMain .= build_shop_bottom_links("ord_Cancel", $cTrans->GetTranslation('shop_order_backtoshop'));
    }
    else
    {
        $contMain .= echo_sr ('<form method="post" action="">');
        $contMain .= echo_sr ('<table class="con_tbl" id="order_con_tbl">');
        $contMain .= echo_sr ('<tr>');
        $contMain .= echo_sr ('  <td>' . $cTrans->GetTranslation('shop_order_image') . '</td>');
        $contMain .= echo_sr ('  <td>' . $cTrans->GetTranslation('shop_order_name') . '</td>');
        $contMain .= echo_sr ('  <td>' . $cTrans->GetTranslation('shop_order_price') . '</td>');
        $contMain .= echo_sr ('  <td>' . $cTrans->GetTranslation('shop_order_count') . '</td>');
        $contMain .= echo_sr ('  <td>' . $cTrans->GetTranslation('shop_order_totalprice') . '</td>');
        $contMain .= echo_sr ('</tr>');
        $artIds = $basket->GetArticleIds();
        $artCounts = $basket->GetCounts();
        $artAddToPrices = $basket->GetAddToPrices();
        $artCNames = array();
        $artCFields = array();
        for ($i = 0; $i < count($artIds); $i ++)
        {
            $contMain .= echo_sr ('<tr>');
            $art->LoadArticleFromId($artIds[$i]);
            $contMain .= echo_sr ('  <td>');
            $contMain .= echo_sr ('  <a href="' . $SHOP_DETAIL_SITE . '?art_id=' . $artIds[$i] . '">');
            $contMain .= echo_sr ('  <img class="order_img" border="0" width="' . $BASKET_IMAGE_WIDTH . '" height="' . $BASKET_IMAGE_HEIGHT . '" src="' . $art->GetImgUrl() . '" title="' . $art->GetName() . '" alt="' . $art->GetName() . '"></a></td>');
            $contMain .= echo_sr ('  <td>' . $art->GetName() . '</td>');
            $contMain .= echo_sr ('  <td>' . format_price($art->GetPrice() + $artAddToPrices[$i]) . ' ' . $SHOP_CURRENCY . '</td>');
            $contMain .= echo_sr ('  <td>' . $artCounts[$i] . '</td>');
            $basketCount += $artCounts[$i];
            $basketValue += (($art->GetPrice() + $artAddToPrices[$i]) * $artCounts[$i]);
            $contMain .= echo_sr ('  <td>' . format_price(($art->GetPrice() + $artAddToPrices[$i]) * $artCounts[$i]) . ' ' . $SHOP_CURRENCY . '</td>');
            $contMain .= echo_sr ('</tr>');
        }
        $contMain .= echo_sr ('</table><br>');
        $contMain .= echo_sr ('</form>');

        $contMain .= echo_sr ('<form method="post" action="">');
        $contMain .= echo_sr ('<table class="con_tbl">');
        $contMain .= echo_sr ('<tr>');
        $contMain .= echo_sr ('  <td width="30%"><br>' . $cTrans->GetTranslation('shop_basket_articlecount') . ':</td>');
        $contMain .= echo_sr ('  <td>' . $basketCount . '</td>');
        $contMain .= echo_sr ('</tr><tr>');
        $contMain .= echo_sr ('  <td width="30%">' . $cTrans->GetTranslation('shop_basket_articlevalue') . ':</td>');
        $contMain .= echo_sr ('  <td>' . format_price($basketValue) . ' ' . $SHOP_CURRENCY. '</td>');
        $contMain .= echo_sr ('</tr><tr>');
        $aShipType = split (';', $SHOP_SHIPPING_TYPE);
        $aShipCost = split (';', $SHOP_SHIPPING_COSTS);
        $contMain .= echo_sr ('  <td width="30%">' . $cTrans->GetTranslation('shop_order_shippingtype') . ':</td>');
        $contMain .= echo_sr ('  <td>');
        $contMain .= echo_sr ('    <select name="ord_shiptypeval" onChange="submit();">');
        for ($i = 0; $i < count($aShipType); $i ++)
        {
            $contMain .= ('      <option value="' . $i . '"');
            if (isset($_POST['ord_shiptypeval']))
            {
                if ($_POST['ord_shiptypeval'] == $i)
                    $contMain .= (' selected');
            }
            $contMain .= echo_sr ('>' . $aShipType[$i] . '</option>');
        }
        $contMain .= echo_sr ('    </select>');
        $contMain .= echo_sr ('  </td>');
        $contMain .= echo_sr ('</tr><tr>');
        $contMain .= echo_sr ('  <td width="30%">' . $cTrans->GetTranslation('shop_order_shippingcosts') . ':</td>');
        $costIndex = 0;
        if (isset($_POST['ord_shiptypeval']))
            $costIndex = $_POST['ord_shiptypeval'];
        $contMain .= echo_sr ('  <td>+ ' . format_price($aShipCost[$costIndex]) . ' ' . $SHOP_CURRENCY );
        $contMain .= echo_sr ('    <input type="hidden" name="ord_shipcost" value="' . $aShipCost[$costIndex] . '">');
        $contMain .= echo_sr ('    <input type="hidden" name="ord_shiptype" value="' . $aShipType[$costIndex] . '">');
        $contMain .= echo_sr ('  </td>');
        $contMain .= echo_sr ('</tr><tr>');
        $contMain .= echo_sr ('  <td width="30%">' . $cTrans->GetTranslation('shop_basket_articlevalue') . ':</td>');
        $contMain .= echo_sr ('  <td><b>' . format_price($basketValue + $aShipCost[$costIndex]) . ' ' . $SHOP_CURRENCY. '</b></td>');
        $contMain .= echo_sr ('</tr>');
        $contMain .= echo_sr ('</table>');
        $contMain .= build_shop_bottom_links("ord_Change", $cTrans->GetTranslation('shop_order_backtobaskter'), "", "", false);

        $contMain .= echo_sr ('<hr><br>');

        if ($DISABLE_ORDER == false)  // Direct order possible?
        {
            // A logged in user?
            $userIsKnown = false;
            if ($checkLogin == true)
            {
                $shopUser = new cUser;
                $shopUserList = new cUserList;
                $shopUser->SetFolder($CUSTOMER_FOLDER);
                $shopUserList->SetFolder($CUSTOMER_FOLDER);
                if ($shopUser->LoadUserFromId($shopUserList->GetUserIdByAlias(get_user_name())) == true)
                    $userIsKnown = true;

            }
            $contMain .= echo_sr ('<table class="con_tbl">');
            $contMain .= echo_sr ('  <tr><td width="30%">' . $cTrans->GetTranslation('shop_order_address') . ':</td><td><br></td></tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_firstname') . ':</td>');
            $userFirstName = "";
            if (isset($_POST['usr_firstname']))
                $userFirstName = $_POST['usr_firstname'];
            else if ($userIsKnown == true)
                $userFirstName = $shopUser->GetFirstName();
            $contMain .= echo_sr ('    <td><input type="text" name="usr_firstname" size="30" value="' . $userFirstName . '"></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_lastname') . ':</td>');
            $userLastName = "";
            if (isset($_POST['usr_lastname']))
                $userLastName = $_POST['usr_lastname'];
            else if ($userIsKnown == true)
                $userLastName = $shopUser->GetLastName();
            $contMain .= echo_sr ('    <td><input type="text" name="usr_lastname" size="30" value="' . $userLastName . '"></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_street') . ':</td>');
            $userStreet = "";
            if (isset($_POST['usr_street']))
                $userStreet = $_POST['usr_street'];
            else if ($userIsKnown == true)
                $userStreet = $shopUser->GetStreet();
            $contMain .= echo_sr ('    <td><input type="text" name="usr_street" size="30" value="' . $userStreet . '"></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_streetno') . ':</td>');
            $userStreetNo = "";
            if (isset($_POST['usr_streetno']))
                $userStreetNo = $_POST['usr_streetno'];
            else if ($userIsKnown == true)
                $userStreetNo = $shopUser->GetStreetNo();
            $contMain .= echo_sr ('    <td><input type="text" name="usr_streetno" size="5" value="' . $userStreetNo . '"></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_zipcode') . ':</td>');
            $userZipCode = "";
            if (isset($_POST['usr_zipcode']))
                $userZipCode = $_POST['usr_zipcode'];
            else if ($userIsKnown == true)
                $userZipCode = $shopUser->GetZipCode();
            $contMain .= echo_sr ('    <td><input type="text" name="usr_zipcode" size="10" value="' . $userZipCode . '"></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_city') . ':</td>');
            $userCity = "";
            if (isset($_POST['usr_city']))
                $userCity = $_POST['usr_city'];
            else if ($userIsKnown == true)
                $userCity = $shopUser->GetCity();
            $contMain .= echo_sr ('    <td><input type="text" name="usr_city" size="30" value="' . $userCity . '"></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_land') . ':</td>');
            $userLand = "";
            if (isset($_POST['usr_land']))
                $userLand = $_POST['usr_land'];
            else if ($userIsKnown == true)
                $userLand = $shopUser->GetLand();
            $contMain .= echo_sr ('    <td><input type="text" name="usr_land" size="30" value="' . $userLand . '"></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_phoneno') . ':</td>');
            $userPhoneNo = "";
            if (isset($_POST['usr_phoneno']))
                $userPhoneNo = $_POST['usr_phoneno'];
            else if ($userIsKnown == true)
                $userPhoneNo = $shopUser->GetTelephoneNo();
            $contMain .= echo_sr ('    <td><input type="text" name="usr_phoneno" size="30" value="' . $userPhoneNo . '"></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_email') . ':</td>');
            $userEmail = "";
            if (isset($_POST['usr_email']))
                $userEmail = $_POST['usr_email'];
            else if ($userIsKnown == true)
                $userEmail = $shopUser->GetEmail();
            $contMain .= echo_sr ('    <td><input type="text" name="usr_email" size="30" value="' . $userEmail . '"></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td></td>');
            $contMain .= ('    <td><input type="checkbox" name="ord_accept" value="1"');
            if (isset($_POST['ord_accept']) && $_POST['ord_accept'] == 1)
                $contMain .= (' checked');
            $contMain .= echo_sr ('><a href="' . $SHOP_TERMS_SITE . '" target="blanc">' . $cTrans->GetTranslation('shop_order_acceptterms') . '</a></td>');
            $contMain .= echo_sr ('  </tr>');
            $contMain .= echo_sr ('  <tr>');
            $contMain .= echo_sr ('    <td></td>');
            $contMain .= ('    <td><input type="checkbox" name="ord_newsletter" value="1"');
            if (isset($_POST['ord_newsletter']) && $_POST['ord_newsletter'] == 1)
                $contMain .= (' checked');
            $contMain .= echo_sr ('>' . $cTrans->GetTranslation('shop_order_newsletter') . '</td>');
            $contMain .= echo_sr ('  </tr>');
            if ($checkLogin == false)  // Checksum only for non-users
            {
                $checkSum = rand(10000, 99999);
                $contMain .= echo_sr ('  <tr>');
                $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_order_checksum') . ': <b>' . $checkSum . '</b></td>');
                $contMain .= echo_sr ('    <td><input type="text" name="ord_checksum" size="5" value=""><input type="hidden" name="ord_checksum_org" value="' . $checkSum . '"></td>');
                $contMain .= echo_sr ('  </tr>');
            }
            $contMain .= echo_sr ('</table>');
            $contMain .= build_shop_bottom_links("ord_FinishOrder", $cTrans->GetTranslation('shop_order_finishorder'),
                                                 "ord_Cancel", $cTrans->GetTranslation('shop_order_cancel'), false);
        }
        else  // direct order is disabled!
        {
            $contMain .= echo_sr ('<p><b>' . $DISABLE_ORDER_MESSAGE . '</b></p>');
            $contMain .= build_shop_bottom_links("ord_Cancel", $cTrans->GetTranslation('shop_order_cancel'),
                                                 "", "", false);
        }
        $contMain .= echo_sr ('</form>');
    }

    // Additional content
    $contAdditional = "";

    // Put content together
    $contContent = build_site_content($ALIGN_TOP, $contMain, $contAdditional);
    $contPage = fill_content($contPage, $contContent, "", "");
    $contPage = fill_emptyvars($contPage);

    echo_r($contPage);
    
?>